// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
using namespace std;

// MODEXP expects: 0<number<2^31, 0<=power<2^63, 0<modulus<2^31
// MODEXP returns: (number^power) % modulus
long long MODEXP(long long number, long long power, long long modulus) { if (power==0) return 1LL % modulus; if (power==1) return number % modulus; long long tmp = MODEXP(number,power/2,modulus); tmp = (tmp*tmp) % modulus; if (power&1) tmp = (tmp*number) % modulus; return tmp; }

int R, S, P=1000000009, N, K;

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  scanf("%d%d%d",&R,&S,&N);

  vector<int> fact(R+S+2);
  fact[0]=fact[1]=1;
  for (int i=2; i<R+S+2; ++i) fact[i] = (1LL * fact[i-1] * i) % P;
  vector<int> inverse(R+S+2);
  for (int i=0; i<R+S+2; ++i) inverse[i] = MODEXP(fact[i],P-2,P);

  while (N--) {
    scanf("%d",&K);
    vector< pair<int,int> > prekazky;
    for (int k=0; k<K; ++k) { 
      int x,y;
      scanf("%d%d",&x,&y);
      prekazky.push_back( make_pair(x,y) );
    }
    sort( prekazky.begin(), prekazky.end(), distless );
    long long result = 0;
    for (int cez=0; cez<(1<<K); ++cez) {
      int sign = (__builtin_popcount(cez)&1) ? -1 : 1;
      long long poc = 1;
      int X[K+2], Y[K+2], ZC=0;
      X[ZC]=0; Y[ZC]=0; ++ZC;
      for (int k=0; k<K; ++k) if (cez & 1<<k) { X[ZC]=prekazky[k].first; Y[ZC]=prekazky[k].second; ++ZC; }
      X[ZC]=R; Y[ZC]=S; ++ZC;
      for (int z=0; z<ZC-1; ++z) {
        long long toto = 0;
        if (X[z+1] >= X[z] && Y[z+1] >= Y[z]) {
          int dx = X[z+1]-X[z], dy = Y[z+1]-Y[z];
          toto = (((1LL * fact[dx+dy] * inverse[dx]) % P) * inverse[dy]) % P;
        }
        poc *= toto;
        poc %= P;
      }
      result += sign * poc;
      result %= P;
    }
    result += P;
    result %= P;
    cout << result << endl;
  }
}
