// another fine solution by misof
#include <algorithm>
#include <iostream>
#include <vector>
#include <cstdio>
#include <set>
#include <map>
using namespace std;
// }}}

int R, S, P=1000000009;
vector< vector<pair<int,int> > > vstupy;
map< pair<int,int>, int > C;

void load() {
  int N;
  scanf("%d%d%d",&R,&S,&N);
  vstupy.resize(N);
  for (int n=0; n<N; ++n) {
    int K;
    scanf("%d",&K);
    while (K--) { 
      int x,y; 
      scanf("%d%d",&x,&y); 
      vstupy[n].push_back( make_pair(x,y) );
    }
  }
}

void precompute() {
  set< pair<int,int> > tmp;
  tmp.insert(make_pair(R,S));
  for (int n=0; n<int(vstupy.size()); ++n) 
    for (int k=0; k<int(vstupy[n].size()); ++k)
      tmp.insert( vstupy[n][k] );
  for (int n=0; n<int(vstupy.size()); ++n) 
    for (int k=0; k<int(vstupy[n].size()); ++k)
      tmp.insert( make_pair(R-vstupy[n][k].first, S-vstupy[n][k].second) );
  for (int n=0; n<int(vstupy.size()); ++n) 
    for (int k=0; k<int(vstupy[n].size()); ++k)
      for (int l=0; l<int(vstupy[n].size()); ++l) if (k!=l) {
        int dr = vstupy[n][k].first - vstupy[n][l].first;
        int ds = vstupy[n][k].second - vstupy[n][l].second;
        if (dr >= 0 && ds >= 0) tmp.insert( make_pair(dr,ds) );
      }

  vector< pair<int,int> > potrebujem( tmp.begin(), tmp.end() );
  potrebujem.push_back( make_pair(R+1,S+1) );
  int p = 0;

  vector<int> comb[2];
  comb[0].resize(S+1,0);
  comb[1].resize(S+1,0);
  for (int r=0; r<=R; ++r) {
    int cur=r%2, prev=1-cur;
    for (int s=0; s<=S; ++s) {
      if (r==0 || s==0)
        comb[cur][s] = 1;
      else {
        comb[cur][s] = comb[prev][s] + comb[cur][s-1];
        if (comb[cur][s] > P) comb[cur][s] -= P;
      }
      if (potrebujem[p].first==r && potrebujem[p].second==s) {
        C[ potrebujem[p] ] = comb[cur][s];
        ++p;
      }
    }
  }
}

bool distless(const pair<int,int> &A, const pair<int,int> &B) {
  return A.first + A.second < B.first + B.second;
}

int main() {
  freopen("mravenci.in", "r", stdin);
  freopen("mravenci.out", "w", stdout);
  load();
  precompute();
  for (int n=0; n<int(vstupy.size()); ++n) {
    vector< pair<int,int> > prekazky = vstupy[n];
    prekazky.push_back( make_pair(R,S) );
    sort( prekazky.begin(), prekazky.end(), distless );
    int K = prekazky.size()-1;
    vector<long long> G(K+1);
    for (int k=0; k<=K; ++k) G[k] = C[ make_pair(prekazky[k].first,prekazky[k].second) ];
    for (int k=0; k<K; ++k)
      for (int l=k+1; l<=K; ++l)
        if (prekazky[l].first >= prekazky[k].first && prekazky[l].second >= prekazky[k].second) {
          G[l] -= G[k] * C[ make_pair( prekazky[l].first - prekazky[k].first, prekazky[l].second - prekazky[k].second ) ];
          G[l] %= P;
          if (G[l] < 0) G[l] += P;
        }
    cout << G[K] << endl;
  }
}
